"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.default = void 0;

var _react = require("react");

var _getQueryPaths = _interopRequireDefault(require("./getQueryPaths"));

var _utils = require("./utils");

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function asyncGeneratorStep(gen, resolve, reject, _next, _throw, key, arg) { try { var info = gen[key](arg); var value = info.value; } catch (error) { reject(error); return; } if (info.done) { resolve(value); } else { Promise.resolve(value).then(_next, _throw); } }

function _asyncToGenerator(fn) { return function () { var self = this, args = arguments; return new Promise(function (resolve, reject) { var gen = fn.apply(self, args); function _next(value) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "next", value); } function _throw(err) { asyncGeneratorStep(gen, resolve, reject, _next, _throw, "throw", err); } _next(undefined); }); }; }

function _objectWithoutProperties(source, excluded) { if (source == null) return {}; var target = _objectWithoutPropertiesLoose(source, excluded); var key, i; if (Object.getOwnPropertySymbols) { var sourceSymbolKeys = Object.getOwnPropertySymbols(source); for (i = 0; i < sourceSymbolKeys.length; i++) { key = sourceSymbolKeys[i]; if (excluded.indexOf(key) >= 0) continue; if (!Object.prototype.propertyIsEnumerable.call(source, key)) continue; target[key] = source[key]; } } return target; }

function _objectWithoutPropertiesLoose(source, excluded) { if (source == null) return {}; var target = {}; var sourceKeys = Object.keys(source); var key, i; for (i = 0; i < sourceKeys.length; i++) { key = sourceKeys[i]; if (excluded.indexOf(key) >= 0) continue; target[key] = source[key]; } return target; }

function _slicedToArray(arr, i) { return _arrayWithHoles(arr) || _iterableToArrayLimit(arr, i) || _nonIterableRest(); }

function _nonIterableRest() { throw new TypeError("Invalid attempt to destructure non-iterable instance"); }

function _iterableToArrayLimit(arr, i) { var _arr = []; var _n = true; var _d = false; var _e = undefined; try { for (var _i = arr[Symbol.iterator](), _s; !(_n = (_s = _i.next()).done); _n = true) { _arr.push(_s.value); if (i && _arr.length === i) break; } } catch (err) { _d = true; _e = err; } finally { try { if (!_n && _i["return"] != null) _i["return"](); } finally { if (_d) throw _e; } } return _arr; }

function _arrayWithHoles(arr) { if (Array.isArray(arr)) return arr; }

function _objectSpread(target) { for (var i = 1; i < arguments.length; i++) { var source = arguments[i] != null ? arguments[i] : {}; var ownKeys = Object.keys(source); if (typeof Object.getOwnPropertySymbols === 'function') { ownKeys = ownKeys.concat(Object.getOwnPropertySymbols(source).filter(function (sym) { return Object.getOwnPropertyDescriptor(source, sym).enumerable; })); } ownKeys.forEach(function (key) { _defineProperty(target, key, source[key]); }); } return target; }

function _defineProperty(obj, key, value) { if (key in obj) { Object.defineProperty(obj, key, { value: value, enumerable: true, configurable: true, writable: true }); } else { obj[key] = value; } return obj; }

function initState(_pageSize) {
  return {
    pageSize: _pageSize,
    intentionPageNum: 1,
    intensionCursorAfter: null,
    timestamp: 0,
    loading: true,
    error: null,
    // loadingFirst: true
    pageNum: null,
    hasPrevPage: null,
    hasNextPage: null,
    arPageNums: [],
    arCursorAfter: [],
    data: null,
    //dataPage
    // dataAll: null,
    pageInfo: null,
    lastPageNum: null
  };
}

function reducer(state, action) {
  switch (action.type) {
    case "setPageNext":
      {
        var intentionPageNum = state.pageNum + 1;
        var intensionCursorAfter = state.pageNum === state.arPageNums.length ? state.pageInfo.endCursor : state.arCursorAfter[intentionPageNum - 1]; // todo:
        //   get cursor of last item on the page

        if (process.env.NODE_ENV === 'development') {
          console.log("reducer setPageNext ".concat(intentionPageNum));
        } // if (intentionPageNum <= state.arPageNums.length) {
        //   const pageNum = intentionPageNum;
        // const pageSize = state.pageSize
        //   const dataPage = state.dataAll.slice((pageNum - 1) * pageSize, pageNum * pageSize);
        //   let hasNextPage = true;
        //   if (state.lastPageNum) {
        //     hasNextPage = pageNum < state.lastPageNum;
        //   }
        //   return {
        //     ...state,
        //     pageNum,
        //     hasNextPage,
        //     hasPrevPage: 1 < pageNum,
        //     data: dataPage
        //   };
        // }


        return _objectSpread({}, state, {
          intentionPageNum: intentionPageNum,
          intensionCursorAfter: intensionCursorAfter,
          // loading: true,
          loading: state.arPageNums.length < intentionPageNum,
          error: null,
          //to repeat after Error
          timestamp: Date.now()
        });
      }

    case "setPagePrev":
      {
        var _intentionPageNum = state.pageNum - 1;

        var _intensionCursorAfter = state.arCursorAfter[_intentionPageNum - 1];

        if (process.env.NODE_ENV === 'development') {
          console.log("reducer setPagePrev ".concat(_intentionPageNum));
        }

        return _objectSpread({}, state, {
          intentionPageNum: _intentionPageNum,
          intensionCursorAfter: _intensionCursorAfter,
          // loading: true,
          loading: false,
          error: null
        }); // const pageNum = intentionPageNum;
        // const pageSize = state.pageSize
        // const dataPage = state.dataAll.slice((pageNum - 1) * pageSize, pageNum * pageSize);
        // let hasNextPage = true;
        // if (state.lastPageNum) {
        //   hasNextPage = pageNum < state.lastPageNum;
        // }
        // return {
        //   ...state,
        //   pageNum,
        //   hasPrevPage: 1 < pageNum,
        //   hasNextPage,
        //   data: dataPage
        // };
      }

    case "setPage":
      {
        var _intentionPageNum2 = action.payload;
        var _intensionCursorAfter2 = state.arCursorAfter[_intentionPageNum2 - 1];

        if (process.env.NODE_ENV === 'development') {
          console.log("reducer setPagePrev ".concat(_intentionPageNum2));
        }

        return _objectSpread({}, state, {
          intentionPageNum: _intentionPageNum2,
          intensionCursorAfter: _intensionCursorAfter2,
          // loading: true,
          loading: false,
          error: null
        });
      }

    case "success":
      var _action$payload = action.payload,
          data = _action$payload.data,
          pageInfo = _action$payload.pageInfo;
      var pageSize = state.pageSize; //if intentional page is empty, dont go to intensional page

      var pageNum = state.intentionPageNum;
      var arPageNums = state.arPageNums.length < pageNum ? state.arPageNums.concat([pageNum]) : state.arPageNums;
      var arCursorAfter = state.arPageNums.length < pageNum ? state.arCursorAfter.concat([state.intensionCursorAfter]) : state.arCursorAfter; // console_log('data')
      // console_log(data)

      var dataPage = data.slice((pageNum - 1) * pageSize, pageNum * pageSize); //let hasNextPage = (pageNum === arPageNums.length && pageInfo.hasNextPage) || pageNum < arPageNums.length
      //const hasNextPage = pageNum < arPageNums.length || (pageNum === arPageNums.length && pageInfo.hasNextPage)

      var hasNextPage = true;
      var lastPageNum = state.lastPageNum;

      if (state.lastPageNum) {
        hasNextPage = pageNum < state.lastPageNum;
      } else if (dataPage.length < pageSize) {
        hasNextPage = false;
        lastPageNum = pageNum;
      }

      if (Array.isArray(dataPage) && dataPage.length === 0) {
        return _objectSpread({}, state, {
          loading: false,
          hasNextPage: false,
          lastPageNum: state.pageNum
        });
      }

      return _objectSpread({}, state, {
        loading: false,
        pageNum: pageNum,
        arPageNums: arPageNums,
        arCursorAfter: arCursorAfter,
        hasPrevPage: 1 < pageNum,
        hasNextPage: hasNextPage,
        data: dataPage,
        // dataAll: data,
        pageInfo: pageInfo,
        lastPageNum: lastPageNum
      });

    case "error":
      if (process.env.NODE_ENV === 'development') {
        console.log("reducer: error");
      }

      return _objectSpread({}, state, {
        error: action.payload,
        loading: false // bad option: becouse
        // intensionCursorAfter: (state.pageNum && state.arCursorAfter[state.pageNum]) || null
        // // ?set lastPageNum on error
        // hasNextPage: false,
        // lastPageNum: state.pageNum

      });

    default:
      throw new Error("usePagination/reducer(): Unknown action.type ".concat(action.type));
  }
}

function usePagination(client, options, pageSize) {
  var refCached = (0, _react.useRef)({});

  var _useReducer = (0, _react.useReducer)(reducer, initState(pageSize)),
      _useReducer2 = _slicedToArray(_useReducer, 2),
      state = _useReducer2[0],
      dispatch = _useReducer2[1];

  var memoOptions = (0, _react.useMemo)(function () {
    if (process.env.NODE_ENV === 'development') {
      console.log('useMemo memoRestOptions');
    }

    var variables = options.variables,
        restOptions = _objectWithoutProperties(options, ["variables"]);

    return _objectSpread({
      variables: variables || {}
    }, restOptions);
  }, // eslint-disable-next-line
  (0, _utils.options2arr)(options));

  var _useMemo = (0, _react.useMemo)(function () {
    return (0, _getQueryPaths.default)(memoOptions.query);
  }, [memoOptions.query]),
      fnJoinResults = _useMemo.fnJoinResults,
      fnGetArray = _useMemo.fnGetArray,
      fnGetPageInfo = _useMemo.fnGetPageInfo;

  var observableQuery = (0, _react.useMemo)(function () {
    var _observable;

    try {
      _observable = client.watchQuery(_objectSpread({}, memoOptions, {
        variables: _objectSpread({}, memoOptions.variables, {
          after: null,
          first: pageSize
        }),
        fetchPolicy: "network-only"
      }));
      refCached.current = {
        "null": true
      };
    } catch (errWatch) {
      dispatch({
        type: "error",
        payload: errWatch
      });
    }

    return _observable;
  }, [client, memoOptions, pageSize]);
  (0, _react.useEffect)(function () {
    if (!observableQuery) {
      return;
    }

    var s = observableQuery.subscribe(function (result) {
      dispatch({
        type: "success",
        payload: {
          data: fnGetArray(result.data),
          pageInfo: fnGetPageInfo(result.data)
        }
      });
    }, function (errSubscr) {
      dispatch({
        type: "error",
        payload: errSubscr
      });
    });
    return function () {
      return s.unsubscribe();
    };
  }, [observableQuery, fnGetArray, fnGetPageInfo]);
  (0, _react.useEffect)(function () {
    function asyncFunctionInEffect() {
      return _asyncFunctionInEffect.apply(this, arguments);
    }

    function _asyncFunctionInEffect() {
      _asyncFunctionInEffect = _asyncToGenerator(
      /*#__PURE__*/
      regeneratorRuntime.mark(function _callee() {
        var prevData, isQueryCached, _options, result, strVaribles, currData;

        return regeneratorRuntime.wrap(function _callee$(_context) {
          while (1) {
            switch (_context.prev = _context.next) {
              case 0:
                if (state.timestamp) {
                  _context.next = 2;
                  break;
                }

                return _context.abrupt("return");

              case 2:
                _context.prev = 2;
                prevData = client.readQuery({
                  query: memoOptions.query
                });
                isQueryCached = state.intensionCursorAfter ? state.intensionCursorAfter in refCached.current : "null" in refCached.current;

                if (!isQueryCached) {
                  _context.next = 8;
                  break;
                }

                //- it will be processed in reduce
                dispatch({
                  type: "success",
                  payload: {
                    data: fnGetArray(prevData),
                    pageInfo: fnGetPageInfo(prevData)
                  }
                });
                return _context.abrupt("return");

              case 8:
                _options = _objectSpread({}, memoOptions, {
                  variables: _objectSpread({}, memoOptions.variables, {
                    first: pageSize,
                    after: state.intensionCursorAfter
                  }),
                  // fetchPolicy: 'network-only',
                  fetchPolicy: 'no-cache'
                });
                _context.next = 11;
                return client.query(_options);

              case 11:
                result = _context.sent;
                strVaribles = state.intensionCursorAfter ? state.intensionCursorAfter : "null";
                refCached.current[strVaribles] = true;
                currData = result.data;
                fnJoinResults(currData, prevData);
                client.writeQuery({
                  query: memoOptions.query,
                  data: currData
                });
                _context.next = 22;
                break;

              case 19:
                _context.prev = 19;
                _context.t0 = _context["catch"](2);
                dispatch({
                  type: "error",
                  payload: _context.t0
                });

              case 22:
              case "end":
                return _context.stop();
            }
          }
        }, _callee, null, [[2, 19]]);
      }));
      return _asyncFunctionInEffect.apply(this, arguments);
    }

    asyncFunctionInEffect(); // }, [state.intensionCursorAfter, pageSize, variables]);
  }, [client, memoOptions, pageSize, fnGetArray, fnGetPageInfo, fnJoinResults, state.intensionCursorAfter, state.timestamp]);

  var goNextPage = function goNextPage() {
    if (state.loading) {
      return;
    }

    if (!state.hasNextPage) {
      return;
    }

    dispatch({
      type: "setPageNext"
    });
  };

  var goPrevPage = function goPrevPage() {
    if (state.loading) {
      return;
    }

    if (!state.hasPrevPage) {
      return;
    }

    dispatch({
      type: "setPagePrev"
    });
  };

  var goPage = function goPage(_pageNum) {
    if (state.loading) {
      return;
    }

    if (!_pageNum) {
      return;
    }

    if (!(0 < _pageNum && _pageNum <= state.arPageNums.length)) {
      return;
    }

    dispatch({
      type: "setPage",
      payload: _pageNum
    });
  };

  return {
    loading: state.loading,
    error: state.error,
    data: state.data,
    //dataAll,
    //dataPage,
    hasPrevPage: state.hasPrevPage,
    goPrevPage: goPrevPage,
    hasNextPage: state.hasNextPage,
    goNextPage: goNextPage,
    goPage: goPage,
    arPageNums: state.hasNextPage,
    pageNum: state.pageNum // ?fnRefetchFistPage

  };
}

;
var _default = usePagination;
exports.default = _default;